/**
 * OBEXR}hC for OBEX Library
 * Copyright(C) 2002,2003 by KEI SAKAKI.
 * 
 * R}hC瑀삷邽߂ɃNX𔼊pɂĂ܂B
 * 
 * java obex put [option] [filename]
 *     -setpath [path]		SETPATHőMpXw肵܂B
 *     -name [name]			NAMEwb_őM閼Ow肵܂B
 *     -type [type]			TYPEwb_őM^Cvw肵܂B
 *     -verbose				oߕ\s悤Ɏw肵܂B
 *     -address [address]	TCP/IPŐڑۂ̐ڑAhXw肵܂B
 *     -port [port]			TCP/IPŐڑۂ̐ڑ|[gw肵܂B
 *     -autoname			NAMEwb_Ƀt@CƓ̂𑗐MۂɎw肵܂B
 *     -userid [userid]		F؎ɎgpUserIdw肵܂B
 *     -password [password]	F؎ɎgpPasswordw肵܂B
 * 
 * java obex get [option] [filename]
 *     -setpath [path]		SETPATHőMpXw肵܂B
 *     -name [name]			NAMEwb_őM閼Ow肵܂B
 *     -type [type]			TYPEwb_őM^Cvw肵܂B
 *     -verbose				oߕ\s悤Ɏw肵܂B
 *     -address [address]	TCP/IPŐڑۂ̐ڑAhXw肵܂B
 *     -port [port]			TCP/IPŐڑۂ̐ڑ|[gw肵܂B
 *     -autoname			NAMEwb_Ƀt@CƓ̂𑗐MۂɎw肵܂B
 *     -userid [userid]		F؎ɎgpUserIdw肵܂B
 *     -password [password]	F؎ɎgpPasswordw肵܂B
 * 
 * java obex server [option]
 *     -put [enable/disable]	PUTIy[VLɂEȂw肵܂B
 *     -get [enable/disable]	GETIy[VLɂEȂw肵܂B
 *     -name [accept/not-accept]	NAMEwb_󂯕t邩E󂯕tȂw肵܂B
 *     -setpath [accept/not-accept]	SETPATHIy[V󂯕t邩E󂯕tȂw肵܂B
 *     -verbose				oߕ\s悤Ɏw肵܂B
 *     -port [port]			TCP/IPŐڑۂ̐ڑ|[gw肵܂B
 *     -userid [userid]		F؎ɎgpUserIdw肵܂B
 *     -password [password]	F؎ɎgpPasswordw肵܂B
 * 
 * java obex help
 */

import java.io.*;
import java.util.*;
import java.net.*;

import personal.sakaki.io.*;

/**
 * R}hC̏ɖ肪ꍇthrowONXłB
 */
class OBEXCommandException extends Exception
{
	OBEXCommandException()
	{
		super();
	}
	
	OBEXCommandException(String msg)
	{
		super(msg);
	}
}

/**
 * NGXgꂽIy[VBODYEND-OF-BODYwb_ꍇɂ󂯎ăt@Cɏޏo̓Xg[NXłB
 */
class RequestReceiveOutputStream extends OutputStream
{
	FileOutputStream fos;
	String filename;
	ObexServerConnection os;
	boolean fVerbose;
	boolean fName;
	String strPath;
	
	RequestReceiveOutputStream(String filename, ObexServerConnection os, boolean fVerbose,
							   boolean fName, String strPath)
	{
		this.filename = filename;
		this.os = os;
		this.fVerbose = fVerbose;
		this.fName = fName;
		this.strPath = strPath;
	}
	
	void fileOpen()
		throws IOException
	{
		if(fVerbose) {
			System.out.println("t@CBODYwb_̓ȅ݂Jn܂B");
			// ̒iKŎ擾łIy[VFINALł͂Ȃ\̂ŒӁB
			System.out.println("Iy[V 0x" + Integer.toHexString(os.getOperation()) + " łB");
		}
		
		//try {
			String strName = os.getName();
			if(fVerbose) {
				System.out.println("NAMEwb_ɂg" + strName + "hn܂B");
			}
			if(fName) {
				filename = os.getName();
			} else {
				if(fVerbose) {
					System.out.println("wɂNAMEwb_𖳎܂B");
				}
			}
		//} catch(RuntimeException ignore) { }

		StringBuffer sbFullPath = new StringBuffer();
		if(strPath != null) {
			sbFullPath.append(strPath);
			if(!strPath.endsWith(File.separator)) sbFullPath.append(File.separator);
		}
		sbFullPath.append(filename);
		String strFullPath = sbFullPath.toString();
		
		if(fVerbose) {
			System.out.println("t@Ćg" + strFullPath + "hłB");
		}
		
		fos = new FileOutputStream(strFullPath);
		
		if(fVerbose) {
			System.out.println("݂Jn܂B");
		}
	}

	public void write(byte[] b)
		throws IOException
	{
		if(b.length == 0) return;
		
		if(fos == null) fileOpen();
		fos.write(b);
	}
	
	public void write(int b)
		throws IOException
	{
		if(fos == null) fileOpen();
		fos.write(b);
	}
	
	public void close()
		throws IOException
	{
		if(fos == null) return;
		
		fos.close();
		
		if(fVerbose) {
			System.out.println("t@Cւ݂̏I܂B");
		}
	}
}

/**
 * OBEXR}hC̏ɊÂčsNXłB
 */
public class obex
{
	static boolean isEnable(String opt, String s)
		throws OBEXCommandException
	{
		s = s.toLowerCase();
		
		if(s.equals("disable")) {
			return false;
		}
		
		if(s.equals("enable")) {
			return true;
		}
		
		throw new OBEXCommandException("IvVg" + opt + "hɂĕsȃp[^g" + s + "hw肳܂B");
	}
	
	static boolean isAccept(String opt, String s)
		throws OBEXCommandException
	{
		s = s.toLowerCase();
		
		if(s.equals("not-accept")) {
			return false;
		}
		
		if(s.equals("accept")) {
			return true;
		}
		
		throw new OBEXCommandException("IvVg" + opt + "hɂĕsȃp[^g" + s + "hw肳܂B");
	}
	
	public static void main(String[] args)
	{
		Vector vecFile = new Vector();
		
		String strPath = null;
		String strName = null;
		String strType = null;
		boolean fVerbose = false;
		boolean fGet = true;
		boolean fGetSet = false;
		boolean fPut = true;
		boolean fPutSet = false;
		String	strTCPAddress = null;
		int		nTCPPort = -1;
		boolean fAutoName = false;
		String strUserId = null;
		String strPassword = null;
		
		ObexClientConnection oc = null;
		ObexServerConnection os = null;

		try {
			if(args.length < 1) {
				throw new OBEXCommandException("R}hw肵ĂB");
			}
			
			for(int i = 1; i < args.length; i++) {
				String strParam = args[i];
				if(strParam.startsWith("-")) {
					try {
						strParam = strParam.substring(1);
						if(strParam.equals("setpath")) {
							strPath = args[++i];
						} else if(strParam.equals("name")) {
							strName = args[++i];
						} else if(strParam.equals("type")) {
							strType = args[++i];
						} else if(strParam.equals("verbose")) {
							fVerbose = true;
						} else if(strParam.equals("put")) {
							fPut = isAccept(args[i], args[++i]);
							fPutSet = true;
						} else if(strParam.equals("get")) {
							fGet = isAccept(args[i], args[++i]);
							fGetSet = true;
						} else if(strParam.equals("address")) {
							strTCPAddress = args[++i];
						} else if(strParam.equals("port")) {
							nTCPPort = Integer.parseInt(args[++i]);
						} else if(strParam.equals("autoname")) {
							fAutoName = true;
						} else if(strParam.equals("userid")) {
							strUserId = args[++i];
						} else if(strParam.equals("password")) {
							strPassword = args[++i];
						} else {
							throw new OBEXCommandException("sȃIvVg" + args[i] + "hw肳܂B");
						}
					} catch(NumberFormatException e) {
						throw new OBEXCommandException("IvVg" + args[i] + "h̃p[^słB");
					} catch(ArrayIndexOutOfBoundsException e) {
						throw new OBEXCommandException("IvVg" + args[i] + "h̃p[^܂B");
					}
				} else {
					vecFile.addElement(strParam);
				}
			}
			
			//if(strPassword == null && strUserId != null) {
			//	throw new OBEXCommandException("-useridIvV-passwordIvVw肵ꍇɂ̂ݎwł܂BB");
			//}
			
			String strCommand = args[0].toLowerCase();
			
			if(strCommand.equals("put")) {
				// IvVgݍ킹`FbN
				if(vecFile.size() == 0) {
					throw new OBEXCommandException("Mt@Cw肵ĂB");
				}
				
				if(fPutSet) {
					throw new OBEXCommandException("-putIvVserver݂̂Ŏgpł܂B");
				}
				
				if(fGetSet) {
					throw new OBEXCommandException("-getIvVserver݂̂Ŏgpł܂B");
				}
				
				if(fAutoName && strName != null) {
					throw new OBEXCommandException("-autonameIvV-nameIvV͔rwłB");
				}
				
				if((strTCPAddress == null && nTCPPort != -1) ||
				   (strTCPAddress != null && nTCPPort == -1)) {
					throw new OBEXCommandException("-addressIvV-tcpIvV̓yAŎgpKv܂B");
				}
				
				//
				
				Socket socket = null;
				if(strTCPAddress != null) {
					socket = new Socket(strTCPAddress, nTCPPort);
				}
				
				//
				if(fVerbose) System.out.println("\[Xmۂ܂B");
				if(socket == null) {
					oc = ObexManager.getClient("IrDA");
				} else {
					oc = ObexManager.getClient("TCP/IP", socket);
				}
				if(fVerbose) System.out.println("mۂ܂B");
				
				if(strPassword != null) {
					if(fVerbose) System.out.println("Fؐݒs܂B");
					oc.setPassword(strPassword);
					if(strUserId != null) {
						oc.setUserId(strUserId);
					}
				}
				
				if(fVerbose) System.out.println("ڑłB");
				oc.connect();
				if(fVerbose) System.out.println("ڑ܂B");
				
				if(strPath != null) {
					oc.setOperation(ObexConnection.SETPATH);
					oc.setName(strPath);
					if(fVerbose) System.out.println("w肳ꂽPATHg" + strPath + "h𑗐M܂B");
					oc.sendRequest();
					if(fVerbose) printStatus(oc);
				}
					
				int nLast = vecFile.size();
				String strTargetFile = null;
				for(int i = 0; i < nLast; i++) {
					strTargetFile = (String) vecFile.elementAt(i);
					if(fVerbose) System.out.println(Integer.toString(nLast) + "  " + (i + 1) + "ڂ̃t@Cg" + strTargetFile + "h̓]Jn܂B");
					
					FileInputStream fis = null;
					try {
						fis = new FileInputStream(strTargetFile);
						
						if(strName != null) {
							oc.setName(strName);
						}
						if(strType != null) {
							oc.setType(strType);
						}
						if(fAutoName) {
							oc.setName(strTargetFile);
						}
						
						oc.setOperation(ObexConnection.PUT);
						if(fVerbose) System.out.println("t@C𑗐MĂ܂B");
						oc.sendRequest(fis, null);
						if(fVerbose) printStatus(oc);
					} catch(FileNotFoundException e) {
						System.out.println("t@Cg" + strTargetFile + "h݂͑܂B");
					} catch(IOException e) {
						System.out.println("t@Cg" + strTargetFile + "h̏ɏQ܂B");
					} finally {
						if(fis != null) {
							try {
								fis.close();
							} catch(IOException ignore) { }
						}
					}
				}
				
				if(fVerbose) System.out.println("SẴt@C̓]I܂B");
			} else if(strCommand.equals("get")) {
				// IvVgݍ킹`FbN
				if(vecFile.size() == 0) {
					throw new OBEXCommandException("擾t@Cw肵ĂB");
				}
				
				if(fPutSet) {
					throw new OBEXCommandException("-putIvVserver݂̂Ŏgpł܂B");
				}
				
				if(fGetSet) {
					throw new OBEXCommandException("-getIvVserver݂̂Ŏgpł܂B");
				}
				
				if(fAutoName && strName != null) {
					throw new OBEXCommandException("-autonameIvV-nameIvV͔rwłB");
				}
				
				if((strTCPAddress == null && nTCPPort != -1) ||
				   (strTCPAddress != null && nTCPPort == -1)) {
					throw new OBEXCommandException("-addressIvV-tcpIvV̓yAŎgpKv܂B");
				}
				
				//
				
				Socket socket = null;
				if(strTCPAddress != null) {
					socket = new Socket(strTCPAddress, nTCPPort);
				}
				
				//
				if(fVerbose) System.out.println("\[Xmۂ܂B");
				if(socket == null) {
					oc = ObexManager.getClient("IrDA");
				} else {
					oc = ObexManager.getClient("TCP/IP", socket);
				}
				if(fVerbose) System.out.println("mۂ܂B");
				
				if(strPassword != null) {
					if(fVerbose) System.out.println("Fؐݒs܂B");
					oc.setPassword(strPassword);
					if(strUserId != null) {
						oc.setUserId(strUserId);
					}
				}
				
				if(fVerbose) System.out.println("ڑłB");
				oc.connect();
				if(fVerbose) System.out.println("ڑ܂B");
				
				if(strPath != null) {
					oc.setOperation(ObexConnection.SETPATH);
					oc.setName(strPath);
					if(fVerbose) System.out.println("w肳ꂽPATHg" + strPath + "h𑗐M܂B");
					oc.sendRequest();
					if(fVerbose) printStatus(oc);
				}
					
				int nLast = vecFile.size();
				String strTargetFile = null;
				for(int i = 0; i < nLast; i++) {
					strTargetFile = (String) vecFile.elementAt(i);
					if(fVerbose) System.out.println(Integer.toString(nLast) + "  " + (i + 1) + "ڂ̃t@Cg" + strTargetFile + "h̓]Jn܂B");
					
					FileOutputStream fos = null;
					try {
						fos = new FileOutputStream(strTargetFile);
						
						if(strName != null) {
							oc.setName(strName);
						}
						if(strType != null) {
							oc.setType(strType);
						}
						if(fAutoName) {
							oc.setName(strTargetFile);
						}
						
						oc.setOperation(ObexConnection.GET);
						if(fVerbose) System.out.println("t@CMĂ܂B");
						oc.sendRequest(null, fos);
						if(fVerbose) printStatus(oc);
					} catch(FileNotFoundException e) {
						System.out.println("t@Cg" + strTargetFile + "h̍쐬Ɏs܂B");
						if(fVerbose) {
							System.out.println("Iy[V𒆎~܂B");
						}
						oc.setOperation(ObexConnection.ABORT);
						oc.sendRequest(null, null);
						if(fVerbose) {
							System.out.println("~܂B");
						}
					} catch(IOException e) {
//e.printStackTrace();
						System.out.println("t@Cg" + strTargetFile + "h̏ɏQ܂B");
						if(fVerbose) {
							System.out.println("Iy[V𒆎~܂B");
						}
						oc.setOperation(ObexConnection.ABORT);
						oc.sendRequest(null, null);
						if(fVerbose) {
							System.out.println("~܂B");
						}
					} finally {
						if(fos != null) {
							try {
								fos.close();
							} catch(IOException ignore) { }
						}
					}
				}
				
				if(fVerbose) System.out.println("SẴt@C̓]I܂B");
			} else if(strCommand.equals("server")) {
				// namesetpath̕]
				
				boolean fName = true;
				boolean fPath = false;
				
				if(strName != null) fName = isAccept("-name", strName);
				if(strPath != null) fPath = isAccept("-setpath", strPath);
				
				// IvVgݍ킹`FbN
				
				if(strType != null) {
					throw new OBEXCommandException("-typeIvVserverł͎gpł܂B");
				}
				
				if(vecFile.size() != 0) {
					throw new OBEXCommandException("serverł̓t@C̎w͍s܂B");
				}
				
				if(strTCPAddress != null) {
					throw new OBEXCommandException("-addressIvVserverł͎gpł܂B");
				}
				
				if(fAutoName) {
					throw new OBEXCommandException("-autonameIvVserverł͎gpł܂B");
				}
				
				// C

				ServerSocket serverSocket = null;
				if(nTCPPort != -1) {
					serverSocket = new ServerSocket(nTCPPort);
				}
				
				if(fVerbose) System.out.println("\[Xmۂ܂B");
				if(serverSocket == null) {
					os = ObexManager.getServer("IrDA");
				} else {
					os = ObexManager.getServer("TCP/IP", serverSocket);
				}
				if(fVerbose) System.out.println("mۂ܂B");
				
				if(strPassword != null) {
					if(fVerbose) System.out.println("Fؐݒs܂B");
					os.setPassword(strPassword);
					if(strUserId != null) {
						if(fVerbose) System.out.println("[U[IDF؎ɋ߂܂B");
						os.setUserId(strUserId);
						os.setRequestUserId(true);
					}
				}
				
				if(fVerbose) System.out.println("serverƂĎtJn܂B");
				os.accept();
				if(fVerbose) {
					System.out.println("NCAgƐڑ܂B");
				}
				
				int num = 0;
				strPath = null;

			server_break:
				while(true) {
					RequestReceiveOutputStream rros = new RequestReceiveOutputStream("server_" + num + ".dat", os, fVerbose, fName, strPath);
					
					if(fVerbose) System.out.println("NCAg̃NGXg҂Ă܂B");
					os.receiveRequest(rros);
					if(fVerbose) {
						System.out.println("NGXg̎M܂B");
						System.out.println("Iy[V 0x" + Integer.toHexString(os.getOperation()) + " łB");
					}
					rros.close();
					num++;
					
					switch(os.getOperation()) {
					case ObexConnection.PUT:
						if(fVerbose) {
							System.out.println("PUTIy[VNGXg܂B");
						}
						
						// IvVXCb`eĂȂFORBIDDEN邢NOT_ACCEPTABLEAMETHOD_NOT_ALLOWEDԂB
						if(!fGet) {
							if(fVerbose) {
								System.out.println("PUT\bh͋Ă܂B");
								System.out.println("X|XMETHOD_NOT_ALLOWEDԂ܂B");
							}
							os.sendResponse(ObexConnection.METHOD_NOT_ALLOWED, null);
							break;
						}
						
						if(fVerbose) {
							//try {
								if(os.getType() != null) {
									System.out.println("Type" + os.getType() + "w肳܂B");									
								}
							//} catch(RuntimeException ignore) { }
						}
						
						if(fVerbose) {
							System.out.println("X|XSUCCESSԂ܂B");
						}
						os.sendResponse(ObexConnection.SUCCESS, null);
						if(fVerbose) {
							System.out.println("X|X̑M܂B");
						}
						break;
						
					case ObexConnection.GET:
						if(fVerbose) {
							System.out.println("GETIy[VNGXg܂B");
						}
						
						// IvVXCb`eĂȂFORBIDDEN邢NOT_ACCEPTABLEAMETHOD_NOT_ALLOWEDԂB
						if(!fPut) {
							if(fVerbose) {
								System.out.println("GET\bh͋Ă܂B");
								System.out.println("X|XMETHOD_NOT_ALLOWEDԂ܂B");
							}
							os.sendResponse(ObexConnection.METHOD_NOT_ALLOWED, null);
							break;
						}
						
						String strFileName = null;
						String strSendType = null;
						byte[] sendBody = null;
						
						// NAMEwb_΃ftHg̃t@CɂB
						//try {
							strFileName = os.getName();
							if(fVerbose) {
								System.out.println("NAMEwb_ɂg" + strFileName + "hw肳܂B");
							}
						//} catch(RuntimeException ignore) { }
						if(strFileName == null) strFileName = "default.body";
						
						// t@C.type΂ǂݎăwb_ɉB
						
						FileInputStream fisType = null;
						ByteArrayOutputStream baosType = null;
						
						try {
							fisType = new FileInputStream(strFileName + ".type");
							byte[] buff = new byte[65535 - 6];	// ̃TCY𒴂邱Ƃ͐΂ɂȂB
							int len = fisType.read(buff);
							if(len != -1) {
								strSendType = new String(buff, 0, len);
							} else {
								if(fVerbose) {
									System.out.println("^Cvt@Cg" + strFileName + ".typeh̓ǂݏoɎs܂B");
								}
							}
						} catch(IOException e) {
							if(fVerbose) {
								System.out.println("^Cvt@Cg" + strFileName + ".typeh܂łB");
							}
						} finally {
							try {
								if(fisType != null) fisType.close();
							} catch(IOException ignore) { }
							
							try {
								if(baosType != null) baosType.close();
							} catch(IOException ignore) { }
						}
		
						// ^Cv̔
						
						//try {
							if(strSendType != null && !os.getType().equals(strSendType)) {
								// UNSUPPORTED_MEDIA_TYPEȁH
								os.sendResponse(ObexConnection.UNSUPPORTED_MEDIA_TYPE, null);
								break;
							}
						//} catch(RuntimeException ignore) { }
						
						// t@CTB
						
						FileInputStream fisBody = null;
						ByteArrayOutputStream baosBody = null;
						
						try {
							fisBody = new FileInputStream(strFileName);
							
							// ewb_̐ݒ
							if(strFileName != null) os.setName(strFileName);
							if(strSendType != null) os.setType(strSendType);
							
							// t@C𑗐MiX|XԂjB
							os.sendResponse(ObexConnection.SUCCESS, fisBody);
							
						} catch(FileNotFoundException e) {
							if(fVerbose) {
								System.out.println("Mt@Cg" + strFileName + "h܂łB");
								System.out.println("NOT_FOUNDXe[^X𑗐M܂B");
							}
						
							// ΃G[X|XԂB
							os.sendResponse(ObexConnection.NOT_FOUND, null);
							
							if(fVerbose) System.out.println("M܂B");
						} finally {
							try {
								if(fisBody != null) fisBody.close();
							} catch(IOException ignore) { }
						}
						
						break;
						
					case ObexConnection.SETPATH:
						if(fVerbose) {
							System.out.println("SETPATHIy[VNGXg܂B");
						}
						
						String strSetPath = null;
						
						//try {
							strSetPath = os.getName();
							if(fVerbose && strSetPath != null) {
								System.out.println("NAMEwb_Łg" + strSetPath + "hʒm܂B");
							}
						//} catch(RuntimeException e) {
						if(strSetPath == null) {
							if(fVerbose) {
								System.out.println("NAMEwb_݂܂łB");
								System.out.println("BAD_REQUESTXe[^XԂ܂B");
							}
							os.sendResponse(ObexConnection.BAD_REQUEST, null);
							if(fVerbose) System.out.println("M܂B");
							break;
						}
						//}
						
						if(strSetPath != null) {
							if(fPath) {
								strPath = strSetPath;
								if(fVerbose) {
									System.out.println("PATHݒ肵܂B");
								}
							} else {
								if(fVerbose) {
									System.out.println("PATHݒ肵܂łB");
								}
							}
						}
						
						// X|XM
						// SUCCESS
						
						if(fVerbose) {
							System.out.println("SUCCESSXe[^XԂ܂B");
						}
						os.sendResponse(ObexConnection.SUCCESS, null);
						if(fVerbose) System.out.println("M܂B");
						
						break;
						
					case ObexConnection.ABORT:
						if(fVerbose) {
							System.out.println("ABORTIy[VNGXg܂B");
						}
						
						// SUCCESSĂ߂ƂƂB
						
						if(fVerbose) {
							System.out.println("SUCCESSXe[^XԂ܂B");
						}
						os.sendResponse(ObexConnection.SUCCESS, null);
						if(fVerbose) System.out.println("M܂B");
						
						break;
						
					case ObexConnection.DISCONNECT:
						if(fVerbose) {
							System.out.println("DISCONNECTIy[VNGXg܂B");
							System.out.println("SUCCESSXe[^X𑗐M܂B");
						}
						
						os.sendResponse(ObexConnection.SUCCESS, null);
						
						if(fVerbose) {
							System.out.println("M܂B");
						}
						
						break server_break;	// ͐ؒfȂ̂ŊO֔
						
					default:
						if(fVerbose) {
							System.out.println("T|[gĂȂIy[VłB");
						}
						os.sendResponse(ObexConnection.NOT_IMPLEMENTED, null);
					}
				}
				
			} else if(strCommand.equals("help")) {
				throw new OBEXCommandException();
			} else {
				throw new OBEXCommandException("sȃR}hg" + strCommand + "hw肳܂B");
			}
			
			if(oc != null) {
				// NCAg̏I
				oc.setOperation(ObexConnection.DISCONNECT);
				if(fVerbose) System.out.println("ڑʒmĂ܂B");
				oc.sendRequest();	// null, null
				if(fVerbose) {
					printStatus(oc);
					System.out.println("ڑ܂B");
				}
				
				oc.close();
				
				if(fVerbose) {
					System.out.println("܂B");
				}
				
				oc = null;
			} else if(os != null) {
				// T[o[̏I
				if(fVerbose) {
					System.out.println("ڑ܂B");
				}
				
				os.close();
				
				if(fVerbose) {
					System.out.println("܂B");
				}
				
				os = null;
			}
		} catch(ConnectException e) {
			System.out.println("w肳ꂽzXgg" + strTCPAddress + "h̃|[gg" + nTCPPort + "hɐڑ邱Ƃł܂łB");
		} catch(UnknownHostException e) {
			System.out.println("w肳ꂽzXgg" + strTCPAddress + "h邱Ƃł܂łB");
		} catch(ObexException e) {
			System.out.println("R[h " + e.getStatus() + " Ŏs܂B");
			System.out.println(e.getMessage());
		} catch(IOException e) {
//e.printStackTrace();
			System.out.println("o͏Ɏs܂B");
		} catch(OBEXCommandException e) {
			System.out.println(
				"OBEX operation tool for OBEX Library\n" +
				"Copyright(C) 2002,2003 by KEI SAKAKI.\n");
			String msg = e.getMessage();
			if(msg != null && !msg.equals("")) {
				System.out.println(msg + "\n");
			}
			System.out.println(
				"t@C𑗐MiNCAgj\n" +
				"    java obex put [option] [filename]\n" +
				"        -setpath [path]\n" +
				"        -name [name]\n" +
				"        -type [type]\n" +
				"        -verbose\n" +
				"        -address [address]\n" +
				"        -port [port]\n" +
				"        -autoname\n" +
				"        -userid [userid]\n" +
				"        -password [password]\n" +
				"    \n" +
				"t@C擾iNCAgj\n" +
				"    java obex get [option] [filename]\n" +
				"        -setpath [path]\n" +
				"        -name [name]\n" +
				"        -type [type]\n" +
				"        -verbose\n" +
				"        -address [address]\n" +
				"        -port [port]\n" +
				"        -autoname\n" +
				"        -userid [userid]\n" +
				"        -password [password]\n" +
				"    \n" +
				"t@C̑MiT[o[j\n" +
				"    java obex server [option]\n" +
				"        -put [enable/disable]\n" +
				"        -get [enable/disable]\n" +
				"        -name [accept/not-accept]\n" +
				"        -setpath [accept/not-accept]\n" +
				"        -verbose\n" +
				"        -port [port]\n" +
				"        -userid [userid]\n" +
				"        -password [password]\n" +
				"    \n" +
				"wvĩbZ[Wj̕\\n" +
				"    java obex help"
			);
		} finally {
			try {
				if(os != null) os.close();
			} catch(ObexException ignore) { }
			
			try {
				if(oc != null) oc.close();
			} catch(ObexException ignore) { }
		}
	}
	
	static void printStatus(ObexClientConnection oc)
	{
		int nStatus = oc.getResponseCode();
		if(nStatus == ObexConnection.SUCCESS) {
			System.out.println("܂B");
		} else {
			System.out.println("s܂BXe[^X 0x" + Integer.toHexString(nStatus) + " łB");
		}
	}
}

